<?php
	class Categories extends CI_Controller{

		public function index(){
			$data['title'] = 'Categories';
			$data['categories'] = $this->model_category->get_categories();
			$this->load->view('templates/header');	
			$this->load->view('categories/index', $data);	
			$this->load->view('templates/footer');	

		}

		public function create(){

			//check login
			if(!$this->session->userdata('logged_in')){redirect('users/login');}
			
			$data['title'] = 'Create Category';
			$this->form_validation->set_rules('name', 'Name', 'required');
			if ($this->form_validation->run() === FALSE){
 				$this->load->view('templates/header');	
				$this->load->view('categories/create', $data);	
				$this->load->view('templates/footer');	
			} else {
				$this->model_category->create_category();

				//set message
				$this->session->set_flashdata('category_created','Your category has been created');

				redirect('categories');
			}
		}

		public function posts($id){
			$data['title'] = $this->model_category->get_category($id)->name;
			$data['posts'] = $this->model_post->get_posts_by_category($id);
			$this->load->view('templates/header');	
			$this->load->view('posts/index', $data);	
			$this->load->view('templates/footer');	
		}

		public function delete($id){

			//check login
			if(!$this->session->userdata('logged_in')){redirect('users/login');}

			$this->model_category->delete_category($id);

			//set message
			$this->session->set_flashdata('category_deleted','Your category has been deleted');

			redirect('categories');
		}
	}